CGAL 6.2 - CGAL and the Boost Graph Library: I/O Functions

CGAL 6.2 - CGAL and the Boost Graph Library

Loading...
Searching...
No Matches
Modules | Functions
I/O Functions
Reference Manual

##

Methods to read and write graphs.

## Modules
| STL I/O Functions
| I/O Functions for the STereoLithography (STL) File Format.
| PLY I/O Functions
| I/O Functions for the Polygon File Format (PLY).
| OBJ I/O Functions
| I/O Functions for the Wavefront Advanced Visualizer Object Format (OBJ).
| OM I/O Functions
| I/O Functions for the OpenMesh (OM) File format.
| OFF I/O Functions
| I/O Functions for the Object File Format (OFF).
| VTP I/O Functions
| I/O Functions for the VTK (VTU / VTP / legacy) File Formats.
| GOCAD I/O Functions
| I/O Functions for the GOCAD (TS) File Format.
| WRL I/O Functions
| I/O Functions for the Virtual Reality Modeling Language (VRML) File Format.
| 3MF I/O Functions
| I/O Functions for the 3D Manufacturing Format (3MF).

## Functions
template<class Graph , typename NamedParameters = parameters::Default_named_parameters>
bool | CGAL::IO::read_polygon_mesh (const std::string &fname, Graph &g, const NamedParameters &np=parameters::default_values())
| reads a polygon mesh from a file.
template<class Graph , typename NamedParameters = parameters::Default_named_parameters>
bool | CGAL::IO::write_polygon_mesh (const std::string &fname, Graph &g, const NamedParameters &np=parameters::default_values())
| writes a polygon mesh in a file.

## Function Documentation

## ◆ read_polygon_mesh()

template<class Graph , typename NamedParameters = parameters::Default_named_parameters>

bool CGAL::IO::read_polygon_mesh | ( | const std::string & | fname,
|  | Graph & | g,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/IO/polygon_mesh_io.h>`

reads a polygon mesh from a file.

Supported file formats are the following:

- Object File Format (OFF) (`.off`)
- Wavefront Advanced Visualizer Object Format (OBJ) (`.obj`)
- OpenMesh (OM) File format (`.om`)
- STereoLithography (STL) File Format (`.stl`)
- Polygon File Format (PLY) (`.ply`)
- GOCAD (TS) File Format (`.ts`)
- VTK (VTU / VTP / legacy) File Formats (`.vtp`)

The format is detected from the filename extension (letter case is not important).

The data is expected to represent a 2-manifold (possibly with borders).

Template Parameters

  Graph | a model of `MutableFaceGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  fname | the name of the file
  g | the mesh
  np | optional Named Parameters described below

Optional Named Parameters

  a property map associating points to the vertices of `g` Type: a class model of `WritablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  whether extra information is printed when an incident occurs during reading Type: Boolean Default: `false` |

Other named parameters may be used according to the file extension, see I/O Functions for an exhaustive list.

Returns
  `true` if reading was successful, `false` otherwise.

See also
  `CGAL::Polygon_mesh_processing::IO::read_polygon_mesh()` if the data is not 2-manifold

Examples
  BGL_surface_mesh/connected_components.cpp, BGL_surface_mesh/prim.cpp, BGL_surface_mesh/seam_mesh.cpp, BGL_surface_mesh/shortest_path.cpp, BGL_surface_mesh/surface_mesh_dual.cpp, and BGL_surface_mesh/surface_mesh_partition.cpp.

## ◆ write_polygon_mesh()

template<class Graph , typename NamedParameters = parameters::Default_named_parameters>

bool CGAL::IO::write_polygon_mesh | ( | const std::string & | fname,
|  | Graph & | g,
|  | const NamedParameters & | np = `parameters::default_values()`
| ) |  |

`#include <CGAL/IO/polygon_mesh_io.h>`

writes a polygon mesh in a file.

Supported file formats are the following:

- Object File Format (OFF) (`.off`)
- Wavefront Advanced Visualizer Object Format (OBJ) (`.obj`)
- STereoLithography (STL) File Format (`.stl`)
- Polygon File Format (PLY) (`.ply`)
- GOCAD (TS) File Format (`.ts`)
- VTK (VTU / VTP / legacy) File Formats (`.vtp`)

The format is detected from the filename extension (letter case is not important).

Template Parameters

  Graph | a model of `FaceListGraph` and `HalfedgeListGraph`
  NamedParameters | a sequence of Named Parameters

Parameters

  fname | the name of the file
  g | the mesh to be output
  np | optional Named Parameters described below

Optional Named Parameters

  a property map associating points to the vertices of `g` Type: a class model of `ReadablePropertyMap` with `boost::graph_traits<Graph>::vertex_descriptor` as key type and `Point_3` as value type Default: `boost::get(CGAL::vertex_point, g)` Extra: If this parameter is omitted, an internal property map for `CGAL::vertex_point_t` must be available in `Graph`. |
  a parameter used to set the precision (i.e. how many digits are generated) of the output stream Type: int Default: `6` Extra: This parameter is only meaningful while using ASCII encoding. |
  indicates whether data should be written in binary (`true`) or in ASCII (`false`) Type: Boolean Default: `true` Extra: This parameter is only meaningful for formats that support binary encoding. |
  whether extra information is printed when an incident occurs during reading Type: Boolean Default: `false` |

Other named parameters may be used according to the file extension, see I/O Functions for an exhaustive list.

Returns
  `true` if writing was successful, `false` otherwise.

Examples
  BGL_surface_mesh/surface_mesh_partition.cpp.